/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "includes.h"

UINT8			optForce;				/* force loading of all resources */
UINT8			optCache;				/* cache loaded resources */
UINT8			optGameRun;				/* status for game */
UINT8			optPCJrGFX;
UINT8			optShowScreenDraw;
UINT8			optShowKeyPress;
UINT16			optEmuVersion;
UINT8			optDebug;

UINT16 parse_cli(UINT16 *ac, UINT8 *args[])
{
	struct vstrings
		{
			UINT16	vers;
			UINT8	*string;
		} cmp_versions[]=
		{
			{0x2089, (UINT8*)"2.089"},
			{0x2272, (UINT8*)"2.272"},
			{0x2440, (UINT8*)"2.440"},
			{0x2917, (UINT8*)"2.917"},
			{0x2936, (UINT8*)"2.936"},

			{0x3086, (UINT8*)"3.002.086"},
			{0x3149, (UINT8*)"3.002.149"},
			{0x0, (UINT8*)""}
		};

	UINT16	ec=err_OK;
	UINT16	count, count2=0;
	AGI_LOADER	*al;
	UINT8	flag;
	UINT16	argc=*ac;
	char	*syntax="Syntax is -:- %s {switches} {gamedir}\n"\
			"\n"\
			"Where {switches} are optionally;\n"\
			"--version\tDisplay version information.\n"\
			"-help\tDisplay this help screen.\n"\
			"-f\tForce loading of all volume information at start of game\n"\
			"\twhich will give you faster play, this also implies the caching.\n"\
			"-c\tCache loading, static resources remain in memory, cached\n"\
			"\tbut are only loaded as needed.\n"\
			"-v{ver}\tForce emulation version\n"\
			"\tWhere {version} is for v2 games; 2.089, 2.272, 2.440, 2.917, 2.936\n"
			"\tand for v3 games; 3.002.086, 3.002.149\n"\
			"-d\tList dictionary words.\n"\
			"-D\tDebug\n"\
			"-o\tList objects.\n"\
			"-p{sk}\tInteractive Picture Viewer.\n"\
			"\ts = Show screen as its drawn.\n"\
			"\tk = Wait for keypress on each action. (* Forces -ps *)\n"\
			"\n"\
			"Where {gamedir} is optionally the directory the game is in, if no directory\n"\
			"is specified, the current directory is assumed.\n"\
			"\n"\
			"eg: yggdrasil -c /games/sierra/sq1-2272 -v2.272\n";
		UINT16 xc;

	optGameRun=gRUN_GAME;
    optCache=__FALSE;
    optForce=__FALSE;
    optPCJrGFX=__FALSE;
    optShowKeyPress=__FALSE;
    optShowScreenDraw=__FALSE;
    optDebug=__FALSE;
    optEmuVersion=0x0;

	if(argc>1)
	{
		for(count=1; ec==err_OK && count<argc; count++)
		{
			flag=0;
			if(strcmp((char*)args[count], (char*)"--version")==NULL)
			{
#ifdef __AGI_V2
				al=&agi_v2;
				/*printf("AGI v%i loader v%s\n", al->version, al->ver_string);*/
#endif
#ifdef __AGI_V3
				al=&agi_v3;
				/*printf("AGI v%i loader v%s\n", al->version, al->ver_string);*/
#endif
				printf("\nCompiled on " __DATE__ "; " __TIME__ "\n");
				flag=1;
				ec=err_DoNothing;
			}
			else
			{
				if(strcmp((char*)args[count], (char*)"-help")==NULL)
				{
					printf(syntax, (char*)args[0]);
					flag=1;
					ec=err_DoNothing;
				}
				else
				{
					if(args[count][0]=='-')
					{
						switch(args[count][1])
						{
							case '?':
								printf(syntax, (char*)args[0]);
								ec=err_DoNothing;
								flag=1;
								break;
							case '1':
								/*
								optPCJrGFX=__TRUE;
								*/
								flag=1;
								break;
							case 'D':
								optDebug=__TRUE;
								flag=1;
								break;
							case 'd':
								optGameRun=gSHOW_WORDS;
								flag=1;
								break;
							case 'o':
								optGameRun=gSHOW_OBJECTS;
								flag=1;
								break;
							case 'v':
								if(strcmp((char*)args[count]+2, (char*)"2.089")==NULL)
									optEmuVersion=0x2089;
								for(xc=0; xc!=0xFFF0 && cmp_versions[xc].vers!=0x0000; xc++)
								{
									if(strcmp((char*)cmp_versions[xc].string, (char*)args[count]+2)==NULL)
									{
										optEmuVersion=cmp_versions[xc].vers;
										xc=0xFFF0-1;
									}
								}

								flag=1;
								break;
							case 'p':
								optGameRun=gVIEW_PICTURES;
								for(count2=1; args[count][count2]!=0x0; count2++)
								{
									switch(args[count][count2])
									{
										case 's':
											optShowScreenDraw=__TRUE;
											break;
										case 'k':
											optShowKeyPress=__TRUE;
											optShowScreenDraw=__TRUE;
											break;
									}
								}
								flag=1;
								break;
							case 'c':
								optCache=__TRUE;
								flag=1;
								break;
							case 'f':
								optForce=__TRUE;
								optCache=__TRUE;
								flag=1;
								break;
							default:
								ec=err_BadCLISwitch;
								break;
						}
					}
				}
			}

			if(flag==1)
			{
				for(count2=count; count2<argc-1; count2++)
					args[count2]=args[count2+1];
				argc--;
				count--;
			}
		}
	}

	if(ec==err_BadCLISwitch)
		printf("\nBad switch syntax;  try -help for information\n");

	*ac=argc;

	return ec;
}
