/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <stdarg.h>

#include "includes.h"

UINT8			font[]=
#include "font.inc"

UINT8			palette[]=
#include "palette.inc"

GFX_DRIVER		*gfx;			/* graphics driver */
UINT8			screen_mode;	/* 0=gfx mode, 1=text mode */
UINT8			txt_fg;			/* fg colour */
UINT8			txt_bg;			/* bg colour */
UINT8			txt_char;		/* input character */

void 	put_text_character(UINT16 x, UINT16 y, UINT8 ch, UINT8 fgc, UINT8 bgc, UINT8 f);
UINT8	*word_wrap_string(UINT8 *message, UINT16 len);
void	draw_box(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2, UINT8 c1, UINT8 c2, UINT8 f);

void message_box(UINT8 *message, ...)
{
	char	x[512];
	va_list	args;

	va_start(args, message);
	vsprintf((char*)&x, (char*)message, args);
	va_end(args);

	textbox((UINT8*)x, -1, -1, -1);

	x[0]=0;
	while(x[0]==0)
	{
		/*agi_get_keypress();*/
		/*if(key_pressed==0x0D || key_pressed==0x1B)*/
		x[1]=getch();
		if(x[1]==0x0D || x[1]==0x01B)
			x[0]=1;
	}
	gfx->put_screen();
}

/*

	len = len in characters, not pixels!!

*/
void textbox(UINT8 *message, SINT16 x, SINT16 y, SINT16 len)
{
	/* if x | y = -1, then centre the box */
	SINT16	xoff, yoff, zoff;
	UINT8	*msg, *m;

	if(len==-1 || len==0)
	{
		m=message;
		xoff=0;
		while(*m!=0x0)
		{
			msg=(UINT8*)strchr((char*)m, 0x0A);
			if(msg==NULL)
				msg=(UINT8*)strchr((char*)m, 0x0);

			if(msg-m>xoff)
				xoff=msg-m;
			if(*msg!=0x0)
				m=msg+1;
			else
				m=msg;
		}
		len=xoff+1;
	}

	if(len>38)
		len=30-2;
	if(len<1)
		len=1;

	xoff=x;
	yoff=y;
	msg=word_wrap_string(message, len);

	len+=2;

	zoff=1 + strlen((char*)msg)/len;
	zoff+=2;

	if(zoff*8>gfx->height)
		zoff=(gfx->height/8);

	if(xoff==-1)
		xoff=(gfx->width - (len*8))/2;
	if(yoff==-1)
		yoff=(gfx->height - (zoff*8))/2;

	draw_box(xoff, yoff, xoff+(len*8), yoff+(zoff*8), MSG_BOX_COLOUR, MSG_BOX_LINE, LINES);

	/* Draw box at x, y */
	/* put text into the box */

	print_text(msg, 8+xoff, 8+yoff, len-1, MSG_BOX_TEXT, MSG_BOX_COLOUR, NO_SAVE);
	free(msg);
}

void print_text(UINT8 *msg, UINT16 xoff, UINT16 yoff, UINT16 len, UINT8 fgc, UINT8 bgc, UINT8 f)
{
	UINT8	*m;
	UINT8	x1, y1;

	m=msg;
	x1=0;
	y1=0;
	while(*m!=0x0)
	{
		if(*m!='\n')
		{
		    put_text_character((x1*8)+xoff, (y1*8)+yoff, *m, fgc, bgc, f);
		    x1++;
		    if(x1==len-1)
		    {
		    	x1=0;
		    	y1++;
		    }
		    m++;
		}
		else
		{
			m++;
			if(*m=='\r')
				m++;
			x1=0;
			y1++;
		}
	}

}

UINT8* word_wrap_string(UINT8 *message, UINT16 len)
{
	UINT8	*msg, *b;
	UINT16	x, y, z;

	/* the font is an 8x8, so scan through and determine the msg box height */

	msg=message;
	if(len>38)
		len=38;
	if(len<1)
		len=1;

	z=0;
	x=0;
	y=1;					/* initial height of message box */

	while(*msg!=0x0)
	{
		x=0;
		while(*msg!=0x0 && isspace(*msg)==0)
		{
			msg++;
			x++;
		}

		if(*msg!=0x0 && *msg!='\n')
		{
			msg++;
			x++;
		}
		if(z+x<=len)
			z+=x;
		else
		{
			z=x;
			y++;
		}

		if(*msg=='\n')
		{
			msg++;
			y++;
			z=0;
		}
	}

	/* now build our padded message box */
	msg=(UINT8*)malloc(len*y + 128);
	b=msg;
	x=0;
	y=0;
	z=0;

	while(*message!=0x0)
	{
		x=0;
		while(*(message+x)!=0x0 && isspace(*(message+x))==0)
			x++;

		if(*(message+x)!=0x0 && *(message+x)!='\n')
			x++;

		/* x = length of word */
		if(z+x<=len)
		{
			z+=x;
			while(x>0)
			{
				if(y==1)
				{
					y=2;
					*b=*message;
					b++;
					message++;
				}
				else
				{
					if(y==2 && *message==0x20)
					{
						message++;
						y=0;
					}
					else
					{
						*b=*message;
						b++;
						message++;
					}
					x--;
				}
			}
		}
		else
		{
			while(z<len)
			{
				z++;
				*b=0x20;
				b++;
			}
			x=0;
			z=0;
		}

		if(*(message+x)=='\n')
		{
			/* pad to line */
			message++;

			while(z<len)
			{
				z++;
				*b=0x20;
				b++;
			}
			x=0;
			z=0;
		}
	}

	/* pad to line */
	if(z!=0)
	{
		while(z<len)
		{
			z++;
			*b=0x20;
			b++;
		}
	}
	*b=0x0;

	return msg;
}

void put_text_character(UINT16 x, UINT16 y, UINT8 ch, UINT8 fgc, UINT8 bgc, UINT8 f)
{
	UINT16	x1, y1;
	UINT8	*p;

	/*if(screen_mode==TXT_MODE)
		bgc+=8;*/

	ch=((ch-0x20)&0x7F);
	if(ch>0x5F)
		ch='?'-0x20;

	p=font+ch*8;
	for(y1=0; y1<8; y1++)
	{
		for(x1=0; x1<8; x1++)
		{
			if((*p&(1<<(8-x1)))!=0)
			{
				gfx->put_pixel(x+x1, y+y1, fgc);
				if(f==SAVE)
					gfx->raw_put_pixel_buffer(x+x1, y+y1, fgc);
			}
			else
			{
				gfx->put_pixel(x+x1, y+y1, bgc);
				if(f==SAVE)
					gfx->raw_put_pixel_buffer(x+x1, y+y1, bgc);
			}
		}
		p++;
	}
}

void draw_box(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2, UINT8 colour1, UINT8 colour2, UINT8 f)
{
	UINT16	x, y;

	if((f&BX_SAVE)==0)
	{
    	for(y=y1; y<y2; y++)
			for(x=x1; x<x2; x++)
				gfx->put_pixel(x, y, colour1);
	}
	else
	{
    	for(y=y1; y<y2; y++)
			for(x=x1; x<x2; x++)
				gfx->raw_put_pixel_buffer(x, y, colour1);
	}

	if((f&LINES)==LINES)
	{
    	/* draw lines */
    	for(x=x1; x<x2-4; x++)
    	{
    		gfx->put_pixel(x+2, y1+2, colour2);
    		gfx->put_pixel(x+2, y2-3, colour2);
    	}

    	for(y=y1; y<=y2-5; y++)
    	{
    		gfx->put_pixel(x1+2, y+2, colour2);
    		gfx->put_pixel(x2-3, y+2, colour2);
    	}
    }
}

UINT8* agi_printf(UINT8 *msg, UINT16 lognum)
{
	static UINT8	x[256];
	static UINT8	y[256];
	UINT8	z[16];
	UINT8	*p;
	UINT16	xx, xy;

	/* turn a AGI string into a real string */
	p=(UINT8*)x;
	*p=0x0;
	xx=0;
	xy=0;
	while(*msg!=0x0)
	{
		switch(*msg)
		{
			case '%':
				msg++;
				switch(*msg++)
				{
					case 'v':
						xx=atoi((char*)msg);
						while(isdigit(*msg)!=0) msg++;
						sprintf((char*)z, "%03i", getvar(xx));

						xy=99;
						if(*msg=='|')
						{
							msg++;
							xy=atoi((char*)msg);
							while(isdigit(*msg)!=0) msg++;
						}
						xx=0;
						if(xy==99)
						{
							/* remove all leading 0' */
							while(z[xx]=='0') xx++;
						}
						else
							xx=3-xy;
						strcat((char*)p, (char*)(z+xx));
						break;
					case '0':
						strcat((char*)p, (char*)objects[atol((char*)msg)-1].name);
						break;
					case 'g':
						strcat((char*)p, (char*)logics[0].texts[atol((char*)msg)-1]);
						break;
					case 'w':
						strcat((char*)p, (char*)words[atol((char*)msg)].word);
						break;
					case 's':
						strcat((char*)p, (char*)strings[atol((char*)msg)]);
						break;
					case 'm':
						strcat((char*)p, (char*)logics[lognum].texts[atol((char*)msg)-1]);
						break;
					default:
						break;
				}

				while(isdigit(*msg)!=0) msg++;
				while(*p!=0x0) p++;
				break;

			default:
				*p=*msg;
				msg++;
				p++;
				*p=0x0;
				break;
		}
	}

	p=(UINT8*)x;
	if(strchr((char*)x, '%')!=NULL)
	{
		strcpy((char*)y, (char*)x);
		p=agi_printf((UINT8*)y, lognum);
	}

	return p;
}

void get_bitmap(UINT8 *dst, UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h)
{
	UINT16	y, x;

	for(y=0; y<h; y++)
	{
		for(x=0; x<w; x++)
		{
			if(y1+y<168 && x1+x<160)
				dst[(y*w)+x]=src[((y1+y)*160)+(x1+x)];
		}
	}
}

void put_bitmap(UINT8 *dst, UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio)
{
	UINT16	x, y;
	UINT8	c;

	for(y=0; y<h; y++)
	{
		for(x=0; x<w; x++)
		{
			c=src[x + y*w];
			if(c!=trans)
				if(y+y1<168 && x+x1<160)
					if(prio>=dst[((y1+y)*160)+(x1+x)])
						dst[((y1+y)*160) + (x1+x)]=c;
		}
	}
}

void agi_put_bitmap(UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio)
{
	UINT16	x, y;
	UINT8	c;

	for(y=0; y<h; y++)
	{
		for(x=0; x<w; x++)
		{
			c=src[x + y*w];
			if(c!=trans)
			{
				if(y+y1<168 && x+x1<160)
				{
					if(prio>=priority_data[((y1+y)*160)+(x1+x)])
					{
						gfx->put_pixel_buffer(x+x1, y+y1, c);
					}
				}
			}
		}
	}
}

void agi_put_bitmap_save(UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio)
{
	UINT16	x, y;
	UINT8	c;

	for(y=0; y<h; y++)
	{
		for(x=0; x<w; x++)
		{
			c=src[x + y*w];
			if(c!=trans)
			{
				if(y+y1<168 && x+x1<160)
				{
					if(prio>=priority_data[((y1+y)*160)+(x1+x)])
					{
						screen_data[((y1+y)*160) + (x1+x)]=c;
						screen2[((y1+y)*160) + (x1+x)]=c;
						gfx->put_pixel_buffer(x+x1, y+y1, c);
					}
				}
			}
		}
	}
}
