/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#ifndef __AGI_GFX
#define __AGI_GFX

#ifdef __cplusplus
extern "C"{
#endif

typedef struct GFX_DRIVER
{
	UINT16	width;
	UINT16	height;

	void	(*kill_mode)(void);
	UINT16	(*init_video_mode)(void);
	UINT16	(*deinit_video_mode)(void);
	UINT16	(*set_palette)(UINT8 *pal, UINT16 startcol, UINT16 numcol);
	UINT16	(*set_cursor_pos)(UINT16 x, UINT16 y);
	void	(*put_pixel)(UINT16 x, UINT16 y, UINT16 c);
	void	(*put_screen)(void);
	void	(*put_block)(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2);

	void	(*put_block_buffer)(UINT8 *buff, UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2);
	void	(*put_pixel_buffer)(UINT16 x, UINT16 y, UINT16 c);
	void	(*raw_put_pixel_buffer)(UINT16 x, UINT16 y, UINT16 c);
	void	(*clear_buffer)(void);
	void	(*clear_bitmap_buffer)(void);
} GFX_DRIVER;

extern	GFX_DRIVER	*gfx;
extern	UINT8		font[];
extern	UINT8		palette[];
extern	UINT8		screen_mode;
extern	UINT8		txt_fg;
extern	UINT8		txt_bg;
extern	UINT8		txt_char;

void	message_box(UINT8 *message, ...);
void	textbox(UINT8 *message, SINT16 x, SINT16 y, SINT16 len);
UINT8	*word_wrap_string(UINT8 *msg, UINT16 len);
UINT8	*agi_printf(UINT8 *msg, UINT16 lognum);
void	get_bitmap(UINT8 *dst, UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h);
void	put_bitmap(UINT8 *dst, UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio);
void	draw_box(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2, UINT8 c1, UINT8 c2, UINT8 f);
void	print_text(UINT8 *msg, UINT16 xoff, UINT16 yoff, UINT16 len, UINT8 fgc, UINT8 bgc, UINT8 flag);
void 	put_text_character(UINT16 x, UINT16 y, UINT8 ch, UINT8 fgc, UINT8 bgc, UINT8 f);


void	agi_put_bitmap(UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio);
void	agi_put_bitmap_save(UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio);
void	agi_put_sprite(UINT8 *src, UINT16 x1, UINT16 y1, UINT16 w, UINT16 h, UINT16 trans, UINT16 prio);

#ifdef __cplusplus
};
#endif
#endif
