/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include "includes.h"

UINT8	o_score=255;
UINT8	o_sound=__FALSE;
UINT8	o_status=__FALSE;


UINT8 hilo_getbyte(UINT8 *mem)
{
	UINT8	c;

	c=(mem[0]);
	return c;
}

UINT16 hilo_getword(UINT8 *mem)
{
	UINT16	c;

	c=(mem[0]<<8) + (mem[1]);
	return c;
}

UINT32 hilo_getpword(UINT8 *mem)
{
	UINT32	c=0;

	c=(mem[0]<<16)+(mem[1]<<8)+(mem[2]);
	return c;
}

UINT32 hilo_getdword(UINT8 *mem)
{
	UINT32	c;

	c=(mem[0]<<24)+(mem[1]<<16)+(mem[2]<<8)+(mem[3]);
	return c;
}

UINT8 lohi_getbyte(UINT8 *mem)
{
	UINT8	c;

	c=(mem[0]);
	return c;
}


UINT16 lohi_getword(UINT8 *mem)
{
	UINT16	c;

	c=(mem[1]<<8) + (mem[0]);
	return c;
}


UINT32 lohi_getpword(UINT8 *mem)
{
	UINT32	c=0;

	c=(mem[2]<<16)+(mem[1]<<8)+(mem[0]);
	return c;
}


UINT32 lohi_getdword(UINT8 *mem)
{
	UINT32	c;

	c=(mem[3]<<24)+(mem[2]<<16)+(mem[1]<<8)+(mem[0]);
	return c;

}


void fixpath(UINT8 flag, UINT8 *fname)
{
	strcpy((char*)path, (char*)gdir);

	if(*path!=0x0 && (path[ strlen((char*)path)-1]!='\\' && path[ strlen((char*)path)-1]!='/'))
	    strcat((char*)path, (char*)PATH_STRING);

	if(flag==1)
	{
		strcat((char*)path, (char*)gname);
		/*if(*path!=0x0 && (path[ strlen((char*)path)-1 ]!='\\' && path[ strlen((char*)path)-1 ]!='/'))
		      strcat((char*)path, (char*)PATH_STRING);
		*/
	}

	strcat((char*)path, (char*)fname);
}


UINT8 getflag(UINT32 number)
{
	UINT8 *set=(UINT8*)&flags;
	UINT8 x;

	set+=number/CHAR_BIT;
	x=*set&(1<<(number%CHAR_BIT));
	if(x==0)
		return __FALSE;
	else
		return __TRUE;
}

void setflag(UINT32 number, UINT8 value)
{
	UINT8 *set=(UINT8*)&flags;

	set+=number/CHAR_BIT;
    if(value==1)
    	*set|=1<<(number%CHAR_BIT);		/* set bit  */
	else
	    *set&=~(1<<(number%CHAR_BIT));		/* clear bit*/
}

void flipflag(UINT32 number)
{
	UINT8 *set=(UINT8*)&flags;

	set+=number/CHAR_BIT;
	*set^=1<<(number%CHAR_BIT);	/* flip bit */
}

void setvar(UINT32 var, UINT8 val)
{
	vars[var]=val;
}

UINT8 getvar(UINT32 var)
{
    return vars[var];
}

void decrypt(UINT8 *mem, UINT32 len)
{
	UINT8	*key=(UINT8*)CRYPT_KEY;
	UINT32	x;

	for(x=0; x<len; x++)
		*(mem+x)^=*(key+(x%11));
}

	/* unload all logic resources */
void unload_resources(void)
{
	UINT16	count;

	for(count=0; count<MAX_DIRS; count++)
	{
		dir_view[count].flags&=~RES_CACHED;			/* remove cache flag */
		loader->unload_resource(rVIEW, count);		/* free view */

		dir_pic[count].flags&=~RES_CACHED;			/* remove chaching flag */
		loader->unload_resource(rPICTURE, count);	/* free resource */

		dir_logic[count].flags&=~RES_CACHED;		/* remove caching flag */
		loader->unload_resource(rLOGIC, count);		/* free resource */

		dir_sound[count].flags&=~RES_CACHED;		/* remove caching flag */
		loader->unload_resource(rSOUND, count);		/* free resource */
	}
}

void new_room_resources(void)
{
	UINT16	x;

	for(x=0; x<MAX_DIRS; x++)
	{
		loader->unload_resource(rVIEW, x);
		loader->unload_resource(rPICTURE, x);
		loader->unload_resource(rLOGIC, x);
	}

	for(x=0; x<MAX_VIEWTABLE; x++)
		reset_view(x);

	// load in new room logic ?
	//loader->load_resource(rLOGIC, new_room_num);
}

void release_sprites(void)
{
	UINT16	count1;

	/* remove background objects from screen */
	for(count1=0; count1<MAX_VIEWTABLE; count1++)
		release_sprite(count1);
}

void release_sprite(UINT16 count1)
{
	if(view_table[count1].bg_scr!=NULL)
	{
		agi_put_bitmap(view_table[count1].bg_scr, view_table[count1].bg_x, view_table[count1].bg_y, view_table[count1].x_size, view_table[count1].y_size, 0xff, 0xff);
		free(view_table[count1].bg_scr);
		view_table[count1].bg_scr=NULL;
	}

	if(view_table[count1].bg_pri!=NULL)
	{
		put_bitmap(xdata_data, view_table[count1].bg_pri, view_table[count1].bg_x, view_table[count1].bg_y, view_table[count1].x_size, view_table[count1].y_size, 0xff, 0xff);
		free(view_table[count1].bg_pri);
		view_table[count1].bg_pri=NULL;
	}
}


void kill_sprites(void)
{
	UINT16	count1;

	/* remove background objects from screen */
	for(count1=0; count1<MAX_VIEWTABLE; count1++)
		kill_sprite(count1);
}

void kill_sprite(UINT16 count1)
{
	if(view_table[count1].bg_scr!=NULL)
	{
		free(view_table[count1].bg_scr);
		view_table[count1].bg_scr=NULL;
	}

	if(view_table[count1].bg_pri!=NULL)
	{
		free(view_table[count1].bg_pri);
		view_table[count1].bg_pri=NULL;
	}
}

char* string_dupe(char *s, int Line, char *File)
{
#ifdef malloc__
	char *x=NULL;
	int z=0;

	if(s!=NULL)
	{
		z=15+strlen(s);
		x=malloc__(z, Line, File);
		if(x!=NULL)
			memmove(x, s, z);
	}
	return(x);
#else
	return strdup(s);
#endif
}

void update_status_line(UINT8 force)
{
	char	x[64];
	char	y[64];


   	if(force==__TRUE || o_status!=status_line || o_score!=getvar(V_score) || o_sound!=getflag(F_sound_on))
   	{
   		o_score=getvar(V_score);
   		o_sound=getflag(F_sound_on);
   		o_status=status_line;

		if(line_min_print>0)
		{
			sprintf(y, " Score:%i of %03i", o_score, getvar(V_max_score));
			sprintf(x, "%-17s             Sound:%s ", y, o_sound==__TRUE ? "On " : "Off");
       		if(status_line==__FALSE)
       		{
       			sprintf(x, "                                       ");
       			print_text((UINT8*)x, line_status, 0, 41, STATUS_FG, STATUS_FG, SAVE);
       		}
       		else
       			print_text((UINT8*)x, line_status, 0, 41, STATUS_FG, STATUS_BG, SAVE);
    	}
   	}
}
