/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>

#include "includes.h"

#ifdef __DJGPP__
#include <pc.h>
#include <go32.h>
#include <sys/farptr.h>
#define __outp(a, b)	outportb(a, b)
#endif

#ifdef __WATCOMC__
#include <i86.h>
#include <conio.h>
#define __outp(a, b)	outp(a, b)
#endif

#ifdef __WATCOMC__
#define move_memory(a, b, c) memmove((char*)a, (char*)b, (UINT32)c)
#endif
#ifdef __DJGPP__
#define move_memory(a, b, c) dosmemput((char*)b, (UINT32)c, (UINT32)a)
#endif

UINT8	*screen_buffer;

void	IBM_kill_mode(void);
UINT16	IBM_init_vidmode(void);
UINT16	IBM_deinit_vidmode(void);
UINT16	IBM_set_palette(UINT8 *pal, UINT16 scol, UINT16 numcols);
UINT16	IBM_set_cursor_pos(UINT16 x, UINT16 y);
void	IBM_blit_screen(void);
void	IBM_blit_block(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2);
void	IBM_put_pixel(UINT16 x, UINT16 y, UINT16 c);

void	IBM_put_block_buffer(UINT8 *buff, UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2);
void	IBM_put_pixel_buffer(UINT16 x, UINT16 y, UINT16 c);
void	IBM_raw_put_pixel_buffer(UINT16 x, UINT16 y, UINT16 c);

void	IBM_clear_buffer(void);
void	IBM_clear_bitmap_buffer(void);

GFX_DRIVER	GFX_ibm=
	{
		320,
		200,

		&IBM_kill_mode,
		&IBM_init_vidmode,
		&IBM_deinit_vidmode,
		&IBM_set_palette,
		&IBM_set_cursor_pos,
		&IBM_put_pixel,
		&IBM_blit_screen,
		&IBM_blit_block,
		&IBM_put_block_buffer,
		&IBM_put_pixel_buffer,
		&IBM_raw_put_pixel_buffer,
		&IBM_clear_buffer,
		&IBM_clear_bitmap_buffer
	};

/*
unsigned char ascii_codes[]=
	{
		0x0, 0x1B, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=', 0x0E, 0x0F,
		'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']', 13, 0, 'a', 's',
        'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '`', 0x1B, 0, '\\', 'z', 'x', 'c', 'v',
        'b', 'n', 'm', ',', '.', '/', 0, '*', 0, ' ', 0, 1, 2, 3, 4, 5,
        6, 7, 8, 9, 10, 0, 0, 24, 25, 26, '-', 21, 22, 23, '+', 18,
        19, 20, 16, 17, 0, 0, 0, 11, 12, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 27, '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+', 14, 15,
        'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '{', '}', 13, 0, 'A', 'S',
        'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '~', '"', 0, '|', 'Z', 'X', 'C', 'V',
        'B', 'N', 'M', '<', '>', '?', 0, '*', 0, ' ', 0, 1, 2, 3, 4, 5,
        6, 7, 8, 9, 10, 0, 0, 24, 25, 26, '-', 21, 22, 23, '+', 18,
        19, 20, 16, 17, 0, 0, 0, 11, 12, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};
*/

UINT16 init_machine(void)
{
	gfx=&GFX_ibm;

	/*txt_bg=0;*/
	/*txt_fg=15;*/
	screen_mode=GFX_MODE;
	screen_buffer=(UINT8*)malloc(gfx->width*gfx->height);
	gfx->clear_buffer();

	return err_OK;
}

UINT16 deinit_machine(void)
{
	free(screen_buffer);

	return err_OK;
}

UINT16 setup_machine(void)
{
	setvar(V_computer, 0);		/* IBM PC */
	setvar(V_soundgen, 1);		/* IBM PC SOUND */
	setvar(V_uknown1, 0x29);	/* unknown */
	setvar(V_monitor, 0x3);		/* EGA monitor */
	return err_OK;
}


UINT8 __file_exists(UINT8 *fname)
{
	UINT8	c=0;
	UINT	rc;

	struct find_t fdata;
	rc=_dos_findfirst((char*)fname, _A_NORMAL | _A_ARCH | _A_RDONLY, &fdata);

	c=(UINT8)rc;
	return c;
}

UINT8* __file_name(UINT8 *fname)
{
	UINT	rc;
	struct find_t fdata;
	short	l;

	fdata.name[0]=0;
	rc=_dos_findfirst((char*)fname, _A_NORMAL, &fdata);
	while(rc==0)
	{
		rc=_dos_findnext(&fdata);
		if(rc==0)
		{
			l=strlen(fdata.name);
			strlwr(fdata.name);
			//printf("%s\n", fdata.name);
			if(strstr(fdata.name, (char*)"dir.")!=NULL)
			//if(fdata.name[l - 1]=='r' && fdata.name[l - 2]=='i' && fdata.name[l - 3]=='d')
			    rc=1;
		}
	}
	return (UINT8*)string_dupe((char*)fdata.name, __LINE__, __FILE__);
}


UINT16 IBM_set_palette(UINT8 *pal, UINT16 scol, UINT16 numcols)
{
	UINT16 i;

	__outp(0x3C8, scol);
	for(i=0; i<numcols*3; i++)
		__outp(0x3C9, pal[scol*3 + i]);

	return err_OK;
}

void IBM_kill_mode(void)
{
	union REGS	r;

	memset(&r, 0x0, sizeof(union REGS));
	r.w.ax=0x3;
	int386(0x10, &r, &r);
}

UINT16 IBM_init_vidmode(void)
{
	union REGS	r;

	memset(&r, 0x0, sizeof(union REGS));
	r.w.ax=0x13;
	int386(0x10, &r, &r);

	screen_mode=GFX_MODE;

	return err_OK;
}

UINT16 IBM_deinit_vidmode(void)
{
	union REGS	r;

	memset(&r, 0x0, sizeof(union REGS));
	r.w.ax=0x03;
	int386(0x10, &r, &r);

	screen_mode=TXT_MODE;

	return err_OK;
}

UINT16 IBM_set_cursor_pos(UINT16 x, UINT16 y)
{
	union REGS	r;

	memset(&r, 0x0, sizeof(union REGS));
	r.w.ax=0x200;
	r.w.bx=0;
	r.w.dx=(x<<8) + y;
	int386(0x10, &r, &r);

	return err_OK;
}

/* copy the screen buffer onto the screen */
void IBM_blit_screen(void)
{
	move_memory(0xA0000, screen_buffer, gfx->width*gfx->height);
}

/* blit a block onto the screen */
void IBM_blit_block(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2)
{
	for( ; y1<y2; y1++)
		move_memory(0xA0000, screen_buffer+(y1*gfx->width)+x1, x2-x1);
}

/* put pixel routine */
void IBM_put_pixel(UINT16 x, UINT16 y, UINT16 c)
{
#ifdef __WATCOMC__
	*((UINT8*)0xA0000+(y*gfx->width)+x)=c;
#endif
#ifdef __DJGPP__
	_farpokeb(_dos_ds, 0xA0000 + (y*gfx->width)+x, c);
#endif
}

void IBM_put_block_buffer(UINT8 *buff, UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2)
{
	UINT16 x;

	for( ; y1<y2; y1++)
	{
		for(x=x1; x<x2; x++)
			gfx->put_pixel_buffer(x, y1, *(buff+(y1*160)+x));
	}
}

void IBM_put_pixel_buffer(UINT16 x, UINT16 y, UINT16 c)
{
	if(line_min_print>0)
		y+=8;
	*(screen_buffer+(y*gfx->width)+(x<<1)+0)=c;
	*(screen_buffer+(y*gfx->width)+(x<<1)+1)=c;
}

void IBM_raw_put_pixel_buffer(UINT16 x, UINT16 y, UINT16 c)
{
	*(screen_buffer+(y*gfx->width)+x)=c;
}


void IBM_clear_buffer(void)
{
	UINT8	c=0;

	if(screen_mode==TXT_MODE)
		c=txt_bg;

	memset(screen_buffer, c, gfx->width*gfx->height);
}

void IBM_clear_bitmap_buffer(void)
{
	UINT8	c=0;
	if(screen_mode==TXT_MODE)
		c=txt_bg;
	memset(screen_buffer, c, gfx->width*160);
}


UINT8 is_keypress(void)
{
	if(!kbhit())
		return __FALSE;
	else
		return __TRUE;
}


UINT16 get_keypress(void)
{
	union REGS	r;
	UINT16	key;

    memset(&r, 0x0, sizeof(union REGS));
    int386(0x16, &r, &r);

	/*
    scan_code=r.h.ah;
    if(r.h.al==0)
    	key_pressed=0;
    else
    {
    	key_pressed=r.h.al;
    	scan_code=0;
    }
	return scan_code*256 + key_pressed;
	*/

	key=r.h.ah*256;
	if(r.h.al==0)
		key&=0xFF00;
	else
		key=r.h.al;

	return key;
}
