/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include "includes.h"

AGI_OBJECT		*objects;				/* objects in the game */
UINT32			num_objects;

UINT16 load_objects(UINT8 *fname)
{
	UINT16	ec=err_OK;
	FILE	*fp;
	UINT32	flen;
	UINT8	*mem;
	UINT16	count, so;

	num_objects=0;
	objects=NULL;

	fixpath(NO_GAMEDIR, fname);
	printf("Loading objects : %s\n", path);
	if((fp=fopen((char*)path, "rb"))!=NULL)
	{
		fseek(fp, 0x0L, SEEK_END);
		flen=ftell(fp);
		fseek(fp, 0x0L, SEEK_SET);

		mem=(UINT8*)calloc(1, flen+32);
		if(mem!=NULL)
		{
			fread(mem, 1, flen, fp);

			/* check if first pointer exceeds file size
			   if so, its encrypted, else it is not */

			if(lohi_getword(mem)>flen)
				decrypt(mem, flen);

			/* alloc memory for object list */
			/* byte 3 = number of animated objects
			   this is ignored.. ?? */

			num_objects=lohi_getword(mem)/3;
			objects=(AGI_OBJECT*)calloc(num_objects, sizeof(AGI_OBJECT));

			if(objects!=NULL)
			{
				/* build the object list */
				for(count=0, so=3; count<num_objects; count++, so+=3)
				{
					(objects+count)->location=lohi_getbyte(mem+so+2);
					/*(objects+count)->name=(UINT8*)strdup((char*)mem+(lohi_getword(mem+so)+3));*/
					(objects+count)->name=(UINT8*)string_dupe((char*)mem+(lohi_getword(mem+so)+3), __LINE__, __FILE__);
				}
			}
			else
				ec=err_NotEnoughMemory;
			free(mem);
		}
		else
			ec=err_NotEnoughMemory;
		fclose(fp);
	}
	else
		ec=err_BadFileOpen;

	return(ec);
}

void unload_objects(void)
{
	UINT16	c;

	if(objects!=NULL)
	{
		for(c=0; c<num_objects; c++)
			free(objects[c].name);
		free(objects);
	}
}


