/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#define _WIDTH	160
#define _HEIGHT	168

/*#define PUSHSORT*/
/*#define DUMPFILL*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <math.h>

#include "includes.h"

#define gbyte data[foffs++]

AGI_PICTURE	pictures[MAX_DIRS];

UINT8	*data;
UINT32	flen;
UINT32	foffs;
CORD	*root;
UINT8	*screen, *priority, *control, *xdata;
UINT8	patCode;
UINT8	patNum;
UINT8	we_are_drawing;
UINT8	pri_on;
UINT8	scr_on;
UINT8	scr_colour;
UINT8	pri_colour;

UINT8	screen2[_WIDTH*_HEIGHT];
UINT8	screen_data[_WIDTH*_HEIGHT];
UINT8	priority_data[_WIDTH*_HEIGHT];
UINT8	control_data[_WIDTH*_HEIGHT];
UINT8	xdata_data[_WIDTH*_HEIGHT];
UINT8	sprite_data[_WIDTH*_HEIGHT];

UINT8	pic_clear_flag=__TRUE;

void	clear_base(void);
void	clear_priority(void);
void	put_virt_pri_pixel(UINT16 x, UINT16 y);
void	put_virt_screen_pixel(UINT16 x, UINT16 y);
void	put_virt_pixel(UINT16 x, UINT16 y);
UINT8	get_scr_pixel(UINT16 x, UINT16 y);
UINT8	get_pri_pixel(UINT16 x, UINT16 y);
void	draw_line(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2);
SINT32	round(float aNumber, float dirn);
void	dump_screen2(void);
void	dump_screen(UINT16 resnum);
void	dump_con(UINT16 resnum);
void	dump_pri(UINT16 resnum);
void	dump_x(UINT16 resnum);
void	draw_picture(void);
void	plot_brush(void);

void	y_corner(void);
void	x_corner(void);
void	absolute_draw_line(void);
void	dynamic_draw_line(void);
void	fill(void);
void	plot_pattern(UINT16 x, UINT16 y);
UINT8	is_ok_fill_here(UINT16 x, UINT16 y);
void	agiFill(UINT16 x, UINT16 y);

CORD	_POP(void);
void	_PUSH(CORD *c);

/* load a pic and decode it into the correct slot */
UINT16 decode_picture(UINT16 resnum)
{
	UINT16	ec=err_OK;

	root=NULL;
	patCode=0;
	patNum=0;
	we_are_drawing=__FALSE;
	pri_on=__FALSE;
	scr_on=__FALSE;
	scr_colour=0xF;
	pri_colour=0x4;
	flen=0;
	foffs=0;

    root=(CORD*)calloc(1, sizeof(CORD));
	data=pictures[resnum].rdata;
	flen=dir_pic[resnum].len;
	foffs=0;

	screen=(UINT8*)malloc(_WIDTH*_HEIGHT);
	priority=(UINT8*)malloc(_WIDTH*_HEIGHT);
	control=(UINT8*)malloc(_WIDTH*_HEIGHT);
	xdata=(UINT8*)malloc(_WIDTH*_HEIGHT);

	pictures[resnum].sdata=screen;
	pictures[resnum].pdata=priority;
	pictures[resnum].cdata=control;
	pictures[resnum].xdata=xdata;

    draw_picture();

	memcpy(pictures[resnum].sdata, &screen_data, _WIDTH*_HEIGHT);
	memcpy(pictures[resnum].pdata, &priority_data, _WIDTH*_HEIGHT);
	memcpy(pictures[resnum].cdata, &control_data, _WIDTH*_HEIGHT);
	memcpy(pictures[resnum].xdata, &xdata_data, _WIDTH*_HEIGHT);

	free(root);
	return ec;
}

UINT16 unload_picture(UINT16 resnum)
{
	if(pictures[resnum].pdata!=NULL)
		free(pictures[resnum].pdata);		/* free priority image */
	if(pictures[resnum].sdata!=NULL)
		free(pictures[resnum].sdata);		/* free screen image */
	if(pictures[resnum].cdata!=NULL)
		free(pictures[resnum].cdata);		/* free control image */
	if(pictures[resnum].xdata!=NULL)
		free(pictures[resnum].xdata);		/* free p+c image */

	pictures[resnum].xdata=NULL;
	pictures[resnum].sdata=NULL;
	pictures[resnum].pdata=NULL;
	pictures[resnum].cdata=NULL;

	return err_OK;
}

void dump_screen(UINT16 resnum)
{
	gfx->put_block_buffer(pictures[resnum].sdata, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_screen2(void)
{
	gfx->put_block_buffer(screen_data, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_pri(UINT16 resnum)
{
	gfx->put_block_buffer(pictures[resnum].pdata, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_con(UINT16 resnum)
{
	gfx->put_block_buffer(pictures[resnum].cdata, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_x(UINT16 resnum)
{
	gfx->put_block_buffer(pictures[resnum].xdata, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_screenX(void)
{
	memmove(&screen_data, &screen2, _WIDTH*_HEIGHT);
	gfx->put_block_buffer(screen_data, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_screen3(void)
{
	gfx->put_block_buffer(screen2, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void dump_pri_screen(void)
{
	gfx->put_block_buffer(priority_data, 0, 0, _WIDTH, _HEIGHT);
	gfx->put_screen();
}

void clear_base(void)
{
	memset(&screen2, 0x0F, _WIDTH*_HEIGHT);
}

void clear_priority(void)
{
	memset(&priority_data, 0x4, _WIDTH*_HEIGHT);
	memset(&control_data, 0x4, _WIDTH*_HEIGHT);
	memset(&xdata_data, 0x4, _WIDTH*_HEIGHT);
}

void put_virt_screen_pixel(UINT16 x, UINT16 y)
{
	screen2[(y*_WIDTH)+x]=scr_colour;
}

void put_virt_pri_pixel(UINT16 x, UINT16 y)
{
	xdata_data[(y*_WIDTH) + x]=pri_colour;
	if(pri_colour>=0x4)
		priority_data[(y*_WIDTH) + x]=pri_colour;
	else
		control_data[(y*_WIDTH) + x]=pri_colour;
}

UINT8 get_scr_pixel(UINT16 x, UINT16 y)
{
	return screen2[(y*_WIDTH) + x];
}

UINT8 get_pri_pixel(UINT16 x, UINT16 y)
{
	return xdata_data[(y*_WIDTH) + x];
}


void put_virt_pixel(UINT16 x, UINT16 y)
{
	if(pri_on==__TRUE)
		put_virt_pri_pixel(x, y);
    if(scr_on==__TRUE)
		put_virt_screen_pixel(x, y);
}

void draw_picture(void)
{
	UINT8	act;

 	patCode=0;
 	patNum=0;
 	pri_on=__FALSE;
 	scr_on=__FALSE;
 	scr_colour=0xF;
 	pri_colour=0x4;

	if(optShowKeyPress==3)
		optShowKeyPress=__TRUE;

	if(pic_clear_flag==__TRUE)
	{
		clear_base();
		clear_priority();
	}

	we_are_drawing=1;

	do
	{
    	act=gbyte;
    	switch(act)
    	{
    		case 0xF0:					/* set colour  screen */
    			scr_colour=gbyte;
    			scr_colour&=0xF;		/* this covers v3 drawing diff */
    			scr_on=__TRUE;
    			break;
    		case 0xF1:					/* disalbe screen drawing */
    			scr_on=__FALSE;
    			break;
    		case 0xF2:					/* set colour priority */
    			pri_colour=gbyte;
    			pri_colour&=0xF;		/* this covers v3 drawing diff */
    			pri_on=__TRUE;
    			break;
    		case 0xF3:					/* disable priority screen */
    			pri_on=__FALSE;
    			break;
    		case 0xF4:					/* y-corner */
    			y_corner();
    			break;
    		case 0xF5:					/* x-corner */
    			x_corner();
    			break;
    		case 0xF6:					/* absolute draw lines */
    			absolute_draw_line();
    			break;
    		case 0xF7:					/* dynamic draw lines */
    			dynamic_draw_line();
    			break;
    		case 0xF8:					/* fill */
    			fill();
    			break;
    		case 0xF9:					/* set pattern */
    			patCode=gbyte;
    			break;
    		case 0xFA:					/* plot brush */
    			plot_brush();
    			break;
    		case 0xFF:					/* end of pic data */
    			we_are_drawing=0;
    			break;
    		default:
            	we_are_drawing=0;
    			break;
    	}
    	if(optShowScreenDraw==__TRUE)
    		dump_screen3();
    	if(optShowScreenDraw==__TRUE && optShowKeyPress==__TRUE)
    	{
    		act=getch();
    		if(act==0) getch();
    		if(act=='c')
    			optShowKeyPress=3;
    	}
    }while(we_are_drawing==1 && foffs<flen);
}


void _PUSH(CORD *c)
{
	CORD	*r, *p;
	UINT8	flag=0;

	r=root->next;

	/* search for same co-ord as in list */
#ifdef PUSHSORT
	while(r!=NULL && flag==0)
 	{
 		if(r->x==c->x && r->y==c->y)
 			flag=1;
		else
		    if(c->x < r->x)
		    	flag=2;
		    else
		    	r=r->next;
 	}
#else
 	while(r!=NULL && flag==0)
 	{
 		if(r->x==c->x && r->y==c->y)
 			flag=1;
 		else
 			r=r->next;
 	}
#endif

	if(flag==2 || r==NULL)
	{
		/* add co-ord */
		if(r==NULL)
		{
			r=root;
			while(r->next!=NULL)
				r=r->next;
		}

		p=(CORD*)calloc(1, sizeof(CORD));
		p->next=r->next;
		r->next=p;

		p->x=c->x;
		p->y=c->y;
	}
}

CORD _POP(void)
{
	CORD c, *p;

	if(root->next!=NULL)
	{
		p=root->next;

		c.x=p->x;
		c.y=p->y;

		root->next=p->next;
		free(p);
	}
	else
	{
		c.x=0xFFFF;
		c.y=0xFFFF;
	}

	return c;
}


/**************************************************************************
** drawline
**
** Draws an AGI line.
**************************************************************************/
void draw_line(UINT16 x1, UINT16 y1, UINT16 x2, UINT16 y2)
{
	SINT32 height, width;
	float x, y, addX, addY;

	height = (y2 - y1);
	width = (x2 - x1);
	addX = (height==0?height:(float)width/abs(height));
	addY = (width==0?width:(float)height/abs(width));

	if (abs(width) > abs(height))
	{
		y = y1;
		addX = (width == 0? 0 : (width/abs(width)));
      	for (x=x1; x!=x2; x+=addX)
      	{
			put_virt_pixel(round(x, addX), round(y, addY));
			y+=addY;
		}
			put_virt_pixel(x2,y2);
	}
	else
	{
		x = x1;
		addY = (height == 0? 0 : (height/abs(height)));
		for (y=y1; y!=y2; y+=addY)
		{
			put_virt_pixel(round(x, addX), round(y, addY));
			x+=addX;
		}
		put_virt_pixel(x2,y2);
	}
}

/**************************************************************************
** relativeDraw
**
** Draws short lines relative to last position.  (drawing action 0xF7)
**************************************************************************/
void dynamic_draw_line(void)
{
	UINT8 x1, y1, disp;
	SINT8 dx, dy;
	UINT8 flag=0;

	x1=gbyte;
	y1=gbyte;

	put_virt_pixel(x1, y1);

	while(flag==0)
	{
		disp=gbyte;
		if (disp >= 0xF0)
			flag=1;
		else
		{
	    	dx = ((disp & 0xF0) >> 4) & 0x0F;
			dy = (disp & 0x0F);
	      	if (dx & 0x08)
	      	    dx = (-1)*(dx & 0x07);
	      	if (dy & 0x08)
	      	    dy = (-1)*(dy & 0x07);
	      	draw_line(x1, y1, x1 + dx, y1 + dy);
	      	x1 += dx;
	      	y1 += dy;
		}
	}
	foffs--;
}

/**************************************************************************
** absoluteLine
**
** Draws long lines to actual locations (cf. relative) (drawing action 0xF6)
**************************************************************************/
void absolute_draw_line(void)
{
   UINT8	x1, y1, x2, y2;
   UINT8	flag=0;

	x1 = gbyte;
	y1 = gbyte;
	put_virt_pixel(x1, y1);
	while(flag==0)
	{
		if ((x2 = gbyte) >= 0xF0)
		    flag=1;
		else
		{
			if ((y2 = gbyte) >= 0xF0)
    		    flag=1;
    		else
    		{
				draw_line(x1, y1, x2, y2);
				x1 = x2;
				y1 = y2;
			}
        }
   }
   foffs--;
}

/**************************************************************************
** round
**
** Rounds a float to the closest int. Takes into actions which direction
** the current line is being drawn when it has a 50:50 decision about
** where to put a pixel.
**************************************************************************/
SINT32 round(float aNumber, float dirn)
{
   if (dirn < 0)
      return (SINT32)((aNumber - floor(aNumber) <= 0.501) ? floor(aNumber) : ceil(aNumber));
   return (SINT32)((aNumber - floor(aNumber) < 0.499)? floor(aNumber) : ceil(aNumber));
}

/**************************************************************************
** okToFill
**************************************************************************/
UINT8 is_ok_fill_here(UINT16 x, UINT16 y)
{
	if (!scr_on && !pri_on)
    	return __FALSE;
   	if (scr_colour == 15)
   	    return __FALSE;
   	if (!pri_on)
   	    return (get_scr_pixel(x, y) == 15);
   	if (pri_on && !scr_on)
   	    return (get_pri_pixel(x, y) == 4);
   	return (get_scr_pixel(x, y) == 15);
}

#define ftest(a) {if(a.x==0xFFFF && a.y==0xFFFF) flag=1;}
/**************************************************************************
** agiFill
**************************************************************************/
void agiFill(UINT16 x, UINT16 y)
{
	CORD c;
	UINT8 flag=0;

	c.x=x;
	c.y=y;
	_PUSH(&c);

	while(flag==0)
	{
		c=_POP();
		if((c.x==0xFFFF) || (c.y==0xFFFF))
			flag=1;
      	else
      	{
			if (is_ok_fill_here(c.x,c.y))
			{
			    put_virt_pixel(c.x, c.y);

			    if (c.x!=0 && is_ok_fill_here(c.x-1, c.y))
			    {
			    	c.x--;
			    	_PUSH(&c);
			    	c.x++;
	    		}

			    if (c.x!=_WIDTH-1 && is_ok_fill_here(c.x+1, c.y))
			    {
			    	c.x++;
			    	_PUSH(&c);
			    	c.x--;
	    		}

			    if (c.y!=_HEIGHT && is_ok_fill_here(c.x, c.y+1))
			    {
			    	c.y++;
			    	_PUSH(&c);
			    	c.y--;
	    		}

	    		if (c.y>0 && is_ok_fill_here(c.x, c.y-1))
	    		{
	    			c.y--;
	    			_PUSH(&c);
	    			c.y++;
	    		}

			}
		}
#ifdef DUMPFILL
		if(optShowScreenDraw==__TRUE)
			dump_screen3();
#endif
	}

	while(root->next!=NULL)
		c=_POP();
}

/**************************************************************************
** xCorner
**
** Draws an xCorner  (drawing action 0xF5)
**************************************************************************/
void x_corner(void)
{
   UINT8 x1, x2, y1, y2, flag=0;

	x1 = gbyte;
	y1 = gbyte;
   	put_virt_pixel(x1,y1);

	while(flag==0)
	{
    	x2=gbyte;
      	if(x2>=0xF0)
      		flag=1;
      	else
      	{
	      	draw_line(x1, y1, x2, y1);
			x1=x2;
			y2=gbyte;
	      	if(y2>=0xF0)
	      		flag=1;
	      	else
	      	{
		      	draw_line(x1, y1, x1, y2);
				y1=y2;
			}
		}
	}
	foffs--;
}


/**************************************************************************
** yCorner
**
** Draws an yCorner  (drawing action 0xF4)
**************************************************************************/
void y_corner(void)
{
   UINT8 x1, x2, y1, y2, flag=0;

	x1 = gbyte;
	y1 = gbyte;
	put_virt_pixel(x1, y1);

	while(flag==0)
	{
		y2=gbyte;
    	if(y2>=0xF0)
        	flag=1;
        else
        {
	    	draw_line(x1, y1, x1, y2);
	      	y1=y2;
	      	x2=gbyte;
	      	if(x2>=0xF0)
	      	    flag=1;
	      	else
	      	{
				draw_line(x1, y1, x2, y1);
				x1=x2;
			}
		}
	}
	foffs--;
}

/**************************************************************************
** fill
**
** Agi flood fill.  (drawing action 0xF8)
**************************************************************************/
void fill(void)
{
	UINT8 x1, y1;
	UINT8 flag=0;

	while(flag==0)
	{
    	if((x1=gbyte)>=0xF0)
    	    flag=1;
    	else
    	{
			if((y1=gbyte)>=0xF0)
			    flag=1;
			else
				agiFill(x1, y1);
		}
	}
	foffs--;
}


#define plotPatternPoint() \
   if (patCode & 0x20) { \
      if ((splatterMap[bitPos>>3] >> (7-(bitPos&7))) & 1) put_virt_pixel(x1, y1); \
      bitPos++; \
      if (bitPos == 0xff) bitPos=0; \
   } else put_virt_pixel(x1, y1)

/**************************************************************************
** plotPattern
**
** Draws pixels, circles, squares, or splatter brush patterns depending
** on the pattern code.
**************************************************************************/
void plotPattern(UINT8 x, UINT8 y)
{
	static char circles[][15] =
	{ /* agi circle bitmaps */
    	{0x80},
	    {0xfc},
	    {0x5f, 0xf4},
	    {0x66, 0xff, 0xf6, 0x60},
	    {0x23, 0xbf, 0xff, 0xff, 0xee, 0x20},
	    {0x31, 0xe7, 0x9e, 0xff, 0xff, 0xde, 0x79, 0xe3, 0x00},
	    {0x38, 0xf9, 0xf3, 0xef, 0xff, 0xff, 0xff, 0xfe, 0xf9, 0xf3, 0xe3, 0x80},
	    {0x18, 0x3c, 0x7e, 0x7e, 0x7e, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7e, 0x7e, 0x7e, 0x3c, 0x18}
	};

	static UINT8 splatterMap[32] =
	{ /* splatter brush bitmaps */
    	0x20, 0x94, 0x02, 0x24, 0x90, 0x82, 0xa4, 0xa2,
	    0x82, 0x09, 0x0a, 0x22, 0x12, 0x10, 0x42, 0x14,
	    0x91, 0x4a, 0x91, 0x11, 0x08, 0x12, 0x25, 0x10,
	    0x22, 0xa8, 0x14, 0x24, 0x00, 0x50, 0x24, 0x04
	};

	static UINT8 splatterStart[128] =
	{ /* starting bit position */
	    0x00, 0x18, 0x30, 0xc4, 0xdc, 0x65, 0xeb, 0x48,
	    0x60, 0xbd, 0x89, 0x05, 0x0a, 0xf4, 0x7d, 0x7d,
	    0x85, 0xb0, 0x8e, 0x95, 0x1f, 0x22, 0x0d, 0xdf,
	    0x2a, 0x78, 0xd5, 0x73, 0x1c, 0xb4, 0x40, 0xa1,
	    0xb9, 0x3c, 0xca, 0x58, 0x92, 0x34, 0xcc, 0xce,
	    0xd7, 0x42, 0x90, 0x0f, 0x8b, 0x7f, 0x32, 0xed,
	    0x5c, 0x9d, 0xc8, 0x99, 0xad, 0x4e, 0x56, 0xa6,
	    0xf7, 0x68, 0xb7, 0x25, 0x82, 0x37, 0x3a, 0x51,
	    0x69, 0x26, 0x38, 0x52, 0x9e, 0x9a, 0x4f, 0xa7,
	    0x43, 0x10, 0x80, 0xee, 0x3d, 0x59, 0x35, 0xcf,
	    0x79, 0x74, 0xb5, 0xa2, 0xb1, 0x96, 0x23, 0xe0,
	    0xbe, 0x05, 0xf5, 0x6e, 0x19, 0xc5, 0x66, 0x49,
	    0xf0, 0xd1, 0x54, 0xa9, 0x70, 0x4b, 0xa4, 0xe2,
	    0xe6, 0xe5, 0xab, 0xe4, 0xd2, 0xaa, 0x4c, 0xe3,
	    0x06, 0x6f, 0xc6, 0x4a, 0xa4, 0x75, 0x97, 0xe1
	};

	SINT32 circlePos = 0;
	UINT32 x1, y1, penSize, bitPos = splatterStart[patNum];

	penSize = (patCode&7);

	if(x<penSize)
	    x=penSize-1;
	if(y<penSize)
	    y=penSize;

	for (y1=y-penSize; y1<=y+penSize; y1++)
	{
	    for (x1=x- (UINT32)(ceil((float)penSize/2) ); x1<=x+ (UINT32)(floor((float)penSize/2) ); x1++)
	    {
			if (patCode & 0x10)
			{ /* Square */
				plotPatternPoint();
      		}
		    else
		    { /* Circle */
				if ((circles[patCode&7][circlePos>>3] >> (7-(circlePos&7)))&1)
				{
					plotPatternPoint();
				}
				circlePos++;
	    	}
		}
	}
}

/**************************************************************************
** plotBrush
**
** Plots points and various brush patterns.
**************************************************************************/
void plot_brush(void)
{
	UINT8 x1, y1;
	UINT8 flag=0;

	while(flag==0)
	{
    	if(patCode&0x20)
    	{
			if((patNum=gbyte) >= 0xF0)
				flag=1;
			else
				patNum=(patNum>>1&0x7f);
     	}
     	if(flag==0)
     	{
			if((x1=gbyte)>=0xF0)
			    flag=1;
			else
			{
				if((y1=gbyte)>=0xF0)
				    flag=1;
				else
					plotPattern(x1, y1);
			}
		}
   	}
   	foffs--;
}

UINT8* convert_v2_v3_pic(UINT8 *data, UINT32 len)
{
	UINT8	d, oldData, outData, *in_buff, *xdata, *out_buff, mode=0;
	UINT32	i=0;

	xdata=(UINT8*)malloc(len + (len/2));
	//xdata=(UINT8*)malloc(len*2);

	out_buff=xdata;
	in_buff=data;

	oldData=0;
	while(i<len)
	{
		d=*in_buff++;
		i++;

		if(mode == 1)
	    	outData=((d&0xF0)>>4) + ((oldData&0x0F)<<4);
      	else
	    	outData=d;

      	if((outData==0xF0) || (outData==0xF2))
      	{
        	*out_buff++=outData;
	      	if(mode==0)
	      	{
            	d=*in_buff++;
            	i++;
            	*out_buff++=((d & 0xF0) >> 4);
	         	mode=1;
	      	}
	      	else
	      	{
            	*out_buff++=(d&0x0F);
	         	mode = 0;
	      	}
      	}
      	else
        	*out_buff++ = outData;
      	oldData = d;
	}

	free(data);
	return xdata;
}
