/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#ifdef __WATCOMC__
void debug(void);
#pragma aux debug="int	0x3" parm [];
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "includes.h"

AGI_VIEW_TABLE	view_table[MAX_VIEWTABLE];		/* 32 animated objects/views */
AGI_VIEW		views[MAX_DIRS];				/* max views */

void init_view_table(void)
{
	UINT16	resnum;

	for(resnum=0; resnum<MAX_VIEWTABLE; resnum++)
	{
		memset(&view_table[resnum], 0x0, sizeof(AGI_VIEW_TABLE));
		view_table[resnum].step_time=1;
		view_table[resnum].step_time_count=1;
		view_table[resnum].step_size=1;
		view_table[resnum].cycle_time=1;
		view_table[resnum].cycle_time_count=1;
		view_table[resnum].cycle_status=0;
	}
}

void reset_view(UINT16 resnum)
{
	if(view_table[resnum].bg_scr!=NULL)
		free(view_table[resnum].bg_scr);
	if(view_table[resnum].bg_pri!=NULL)
		free(view_table[resnum].bg_pri);

	view_table[resnum].bg_scr=NULL;
	view_table[resnum].bg_pri=NULL;
	view_table[resnum].flags&=~(UPDATE | ANIMATED);

	view_table[resnum].step_time=1;
	view_table[resnum].step_time_count=1;
	view_table[resnum].step_size=1;
	view_table[resnum].cycle_time=1;
	view_table[resnum].cycle_time_count=1;
	view_table[resnum].cycle_status=0;
}

void reset_views(void)
{
	UINT16	resnum;

	for(resnum=0; resnum<MAX_DIRS; resnum++)
		loader->unload_resource(rVIEW, resnum);

	for(resnum=0; resnum<MAX_VIEWTABLE; resnum++)
		reset_view(resnum);
}

/* unloads ALL data in a VIEW, not a VIEWTABLE entry */
void unload_view(UINT16 resnum)
{
	UINT16		x, y;

	/* free all the loops */
	for(x=0; x<views[resnum].num_loops; x++)
	{
		for(y=0; y<views[resnum].loop[x].num_cels; y++)
			if(views[resnum].loop[x].cel[y].data!=NULL)
				free(views[resnum].loop[x].cel[y].data);

		if(views[resnum].loop[x].cel!=NULL)
			free(views[resnum].loop[x].cel);
	}

	/* free the loops */
	if(views[resnum].loop!=NULL)
		free(views[resnum].loop);
	views[resnum].loop=NULL;

	/* free the description ascociated with the view */

	/*
	if(views[resnum].descr!=NULL)
		free(views[resnum].descr);
	*/
	views[resnum].descr=NULL;

	/* release RAW data for view */
	if(views[resnum].rdata!=NULL)
		free(views[resnum].rdata);
	views[resnum].rdata=NULL;
}

UINT16 decode_view(UINT16 resnum)
{
	UINT16		ec=err_OK;
	UINT8		*a1, *a2, *a3;
	UINT16		count1, count2, count3, count4, count5;
	UINT16		laddress, celaddress;
	UINT8		cd, col, len;
	VIEW_LOOP	*vl;
	VIEW_CEL	*vc;
	UINT8		zbuff[256];
	UINT16		zback;

	a1=views[resnum].rdata;

   	if(lohi_getword(a1+3)!=0)
   		views[resnum].descr=(UINT8*)string_dupe((char*)a1 + lohi_getword(a1+3), __LINE__, __FILE__);
   	else
   		views[resnum].descr=(UINT8*)string_dupe((char*)null_msg, __LINE__, __FILE__);

   	views[resnum].num_loops=lohi_getbyte(a1+2);

   	/* decode all the loops in the VIEW */
   	if(views[resnum].num_loops>0)
   	{
   		/* allocate space for each loop in a view */
   		views[resnum].loop=(VIEW_LOOP*)malloc(views[resnum].num_loops * sizeof(VIEW_LOOP));

   		if(views[resnum].loop!=NULL)
   		{
       		/* decode all the loops here */
       		/* a2 points to first loop address */
       		a2=a1+5;
           	for(count1=0; count1<views[resnum].num_loops; count1++, a2+=2)
           	{
#ifdef VIEWDEBUG
       			printf("\nLoop %u : Frames=%u : %08lX\n", count1, views[resnum].num_loops, (UINT32)a2);
#endif
           		/* decode all the cells in a loop */
           		laddress=lohi_getword(a2);
       			vl=&views[resnum].loop[count1];
           		vl->num_cels=lohi_getbyte(a1+laddress);
           		vl->cel=(VIEW_CEL*)malloc((2+vl->num_cels)*sizeof(VIEW_CEL));
           		if(vl->cel!=NULL)
           		{
               		for(count2=0; count2<vl->num_cels; count2++)
               		{
                    	celaddress=laddress+lohi_getword(a1+laddress+1+(count2*2));
               			vc=&vl->cel[count2];

#ifdef __WATCOMC__
						debug();
#endif

               			vc->width=lohi_getbyte(a1+celaddress+0);
               			vc->height=lohi_getbyte(a1+celaddress+1);

               			vc->transparency=(lohi_getbyte(a1+celaddress+2))&0xF;
               			vc->mirror_loop=(lohi_getbyte(a1+celaddress+2))>>4;
               			vc->mirror=(lohi_getbyte(a1+celaddress+2))>>4;

						//vc->mirror=vc->mirror&0x1;
						//vc->mirror_loop=vc->mirror_loop>>1;

						vc->mirror=vc->mirror>>3;
						vc->mirror_loop=vc->mirror_loop&0x7;

           				celaddress+=3;
#ifdef VIEWDEBUG
           				printf("Loop %u, Cel %u : %ux%u\n", count1, count2, vc->width, vc->height);
#endif
     					a3=(UINT8*)malloc(vc->height * vc->width);
     					vc->data=a3;
     					if(a3!=NULL)
     					{
             				for(count3=0, count5=0; count3<vc->height; count3++)
             				{
             					count4=0;
             					do
             					{
             						cd=lohi_getbyte(a1+celaddress+count5++);
             						col=(cd>>4)&0xF;
             						len=(cd&0xF);
             						for( ; len>0 && count4<vc->width; len--, count4++)
             						{
             							a3[(count3 * vc->width)+count4]=col;
             							zbuff[count4]=col;
             						}
             					}while(cd!=0x0 && count4<vc->width);

             					while(cd!=0) cd=lohi_getbyte(a1+celaddress+count5++);

             					for( ; count4<vc->width; count4++)
             					{
             						a3[(count3*vc->width)+count4]=vc->transparency;
             						zbuff[count4]=vc->transparency;
             					}

             					/* if line is mirrored, reverse line into
             					   zbuffer and put it back in */
								/* if mirrored and the mirror'd loop is not this loop */
             					if(vc->mirror==1 && vc->mirror_loop!=count1)
             					{
             						zback=vc->width-1;
             						for(count4=0; count4<vc->width; count4++, zback--)
             							a3[(vc->width*count3)+count4]=zbuff[zback];
             					}
             				}
             			}
             			else
             			{
             				vc->data=NULL;
 				        	ec=err_NotEnoughMemory;
             			}
               		}
               	}
               	else
               		ec=err_NotEnoughMemory;
         	}
        }
		else
			ec=err_NotEnoughMemory;
   	}
   	else
   		views[resnum].loop=NULL;

	return(ec);
}

void add_view_table(UINT8 entry, UINT8 vw)
{
	view_table[entry].bg_scr=NULL;
	view_table[entry].bg_pri=NULL;
	view_table[entry].cycle_status=0;
	view_table[entry].cur_cel=0;
	view_table[entry].current_loop=0;
	view_table[entry].motion=0;

	view_table[entry].current_view=vw;
	view_table[entry].view=&views[vw];
	set_loop(entry, 0);
	set_cel(entry, 0);
}

void set_cel(UINT8 entry, UINT8 cel)
{
	view_table[entry].cur_cel=cel;
	view_table[entry].cel=&view_table[entry].loop->cel[cel];
	view_table[entry].x_size=view_table[entry].loop->cel[cel].width;
	view_table[entry].y_size=view_table[entry].loop->cel[cel].height;
	view_table[entry].num_cels=view_table[entry].loop->num_cels;
}

void set_loop(UINT8 entry, UINT8 loop)
{
	view_table[entry].current_loop=loop;
	view_table[entry].loop=&view_table[entry].view->loop[loop];
	view_table[entry].num_cels=view_table[entry].loop->num_cels;
	view_table[entry].num_loops=view_table[entry].view->num_loops;
}

void add_to_pic(UINT8 view, UINT8 loop, UINT8 cel, UINT8 x, UINT8 y, UINT8 priority, UINT8 margin)
{
	/* copy a bitmap onto the main screen */
	/* check for cel mirror */
	VIEW_CEL	*c;
	short	x1, y1;

	c=&views[view].loop[loop].cel[cel];

	if((SINT16)(y-c->height)>0)
		y-=c->height;
	else
		y=0;

	agi_put_bitmap_save(c->data, x, y, c->width, c->height, c->transparency&0xF, priority);

	/* dont forget to add a priority box around it.... */
	if(margin<4)
	{
		/* add rectangle around object ... */
		for(y1=y; y1<c->height; y1++)
		{
			for(x1=x; x1<c->width; x1++)
				xdata_data[y1*160 + x1]=margin;
		}
	}
}

void calc_direction(UINT8 vt)
{
	if((view_table[vt].flags&FIX_LOOP)==0)
	{
		if(view_table[vt].num_loops<4)
		{
			switch(view_table[vt].direction)
			{
				case 1:
				case 5: break;
				case 2:
				case 3:
				case 4:
				case 6:
				case 7:
				case 8: set_loop(vt, 0); break;
			}
		}
		else
		{
			switch(view_table[vt].direction)
			{
				case 1: set_loop(vt, 3); break;
				case 2:
				case 3:
				case 4: set_loop(vt, 0); break;
				case 5: set_loop(vt, 2); break;
				case 6:
				case 7:
				case 8: set_loop(vt, 1); break;
			}
		}
	}
}

void draw_obj(UINT8 vt)
{
	UINT16 flags;

	flags=view_table[vt].flags;
	/* save bg co-ords */
	view_table[vt].bg_x=view_table[vt].x_pos;
	view_table[vt].bg_y=view_table[vt].y_pos-view_table[vt].y_size;

	/* copy background */
	view_table[vt].bg_scr=(UINT8*)malloc(view_table[vt].x_size * view_table[vt].y_size);
	get_bitmap(view_table[vt].bg_scr, screen_data, view_table[vt].bg_x, view_table[vt].bg_y, view_table[vt].x_size, view_table[vt].y_size);

	view_table[vt].bg_pri=(UINT8*)malloc(view_table[vt].x_size * view_table[vt].y_size);
	get_bitmap(view_table[vt].bg_pri, xdata_data, view_table[vt].bg_x, view_table[vt].bg_y, view_table[vt].x_size, view_table[vt].y_size);

	if(!((view_table[vt].flags&FIXED_PRIORITY)==FIXED_PRIORITY))
	{
		if(view_table[vt].y_pos<60)
			view_table[vt].priority=4;
		else
			view_table[vt].priority=(view_table[vt].y_pos/12)+1;
	}

	calc_direction(vt);

	agi_put_bitmap(view_table[vt].cel->data,
		view_table[vt].x_pos,
		view_table[vt].y_pos-view_table[vt].y_size,
		view_table[vt].x_size, view_table[vt].y_size,
		view_table[vt].cel->transparency&0xF, view_table[vt].priority);

}
