/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "includes.h"

AGI_WORD		*words;					/* words in the game */
UINT32			num_words, num_syns;

UINT16	find_word(UINT8 *word);
void	fix_users_words(UINT8 *msg);

UINT16 load_words(UINT8 *fname)
{
	UINT16	ec=err_OK;
	FILE	*fp;
	UINT32	flen;
	UINT8	*mem;

	UINT16	sc, wc, woff, wid;
	UINT8	x[128];
	char	c;

	num_words=0;
	num_syns=0;
	words=0;

	fixpath(NO_GAMEDIR, fname);
	printf("Loading dictionary : %s\n", path);
	if((fp=fopen((char*)path, "rb"))!=NULL)
	{
		fseek(fp, 0x0L, SEEK_END);
		flen=ftell(fp);
		fseek(fp, 0x0L, SEEK_SET);

		mem=(UINT8*)calloc(1, flen+32);
		if(mem!=NULL)
		{
			fread(mem, 1, flen, fp);

			/* scan for first entry with words */
			for(wc=0, woff=0; woff==0; wc+=2)
				woff=hilo_getword(mem+wc);

			/* count all the words in the list */
			for(sc=0, wc=0; woff<flen; )
			{
				c=hilo_getbyte(mem+woff); woff++;
				if(c>0x80)
				{
					wc++;
					wid=hilo_getword(mem+woff); woff+=2;
					if(wid>sc && wid!=9999)
						sc=wid;
				}
			}
			num_words=wc;
			num_syns=sc;

			/* scan for frist words entry */
			for(wc=0, woff=0; woff==0; wc+=2)
				woff=hilo_getword(mem+wc);

			/* alloc word memory */

			words=(AGI_WORD*)calloc(num_words, sizeof(AGI_WORD));
			if(words!=NULL)
			{
				/* build word list */
				for(wc=0; wc<num_words; wc++)
				{
					c=hilo_getbyte(mem+woff); woff++;
					wid=c;
					while(c<0x80)
					{
						c=hilo_getbyte(mem+woff); woff++;
						x[wid]=((c^0x7F)&0x7F); wid++;
					}
					x[wid]=0x0;

					(words+wc)->id=hilo_getword(mem+woff); woff+=2;
					/*(words+wc)->word=(UINT8*)strdup((char*)x);*/
					(words+wc)->word=(UINT8*)string_dupe((char*)x, __LINE__, __FILE__);
					/*
					printf("%04i.%s\n", (words+wc)->id, (words+wc)->word);
					*/
				}
			}
			else
				ec=err_NotEnoughMemory;
			free(mem);
		}
		else
			ec=err_NotEnoughMemory;
		fclose(fp);
	}
	else
		ec=err_BadFileOpen;

	return ec;
}

void unload_words(void)
{
	UINT16	c;

	if(words!=NULL)
	{
		for(c=0; c<num_words; c++)
			free(words[c].word);
		free(words);
	}
}

/*
Scan dictionary for word, returning its ID.
Uses a fast "Divide and Conquer" routine to get the word your looking for.
*/

UINT16 find_word(UINT8 *word)
{
	UINT16	hwords;
	SINT16	offs;
	UINT16	id;
	UINT8	flag;
	SINT16	val;
	UINT16	maxid;

	offs=num_words/2;
	hwords=offs/2;
	flag=0;
	id=0;
	maxid=0;

	while(flag!=255)
	{
		val=strcmp((char*)words[offs].word, (char*)word);

		if(val<0)
			offs+=hwords;
		if(val>0)
			offs-=hwords;
		if(val==0)
		{
			flag=255;
			id=words[offs].id;
			maxid=offs;
		}

		hwords/=2;
		if(offs<0)
			offs=0;
		if((UINT16)offs>num_words)
			offs=num_words;

		if(flag!=255)
		{
			if(flag<5 && hwords==0)
			{
				hwords=1;
				flag++;
			}
			if(flag==5)
			{
				flag=255;
				maxid=(SINT16)-1;
			}
		}
	}

	return(maxid);
}

void dictionary_words(UINT8 *msg)
{
	/* turn all words in msg into ego's words */
	fix_users_words(msg);

	if(num_ego_words>0)
	{
		setflag(F_entered_cli, __TRUE);
		setflag(F_said_accepted_input, __FALSE);
	}
}

void fix_users_words(UINT8 *msg)
{
	UINT8	x[64];
	UINT8	*p;
	UINT8	last=0;
	SINT16	wc1;

	/* remove all the crap from their strings */

	strcpy((char*)x, (char*)msg);

	p=(UINT8*)x;
	while(*msg!=0x0)
	{
		/* lowercase all words */
		if(*msg==0x20 || isalnum(*msg)!=0)
        {
        	if(*msg==0x20 && last==0x20)
        		msg++;
			else
			{
				*p=tolower(*msg);
				last=*p;
				p++;
				msg++;
			}
		}
		else
			msg++;
	}

	clean_input();

	p=(UINT8*)x;
	while(p!=NULL && *p!=0x0)
	{
		wc1=find_word(p);
		if(wc1!=-1)
		{
    		switch(words[wc1].id)
    		{
    			case -1:
    				setvar(V_word_not_found, 1+num_ego_words);
    				p=(UINT8*)strchr((char*)p, 0x20);
    				num_ego_words++;
    				break;
    			case 0:
    				/* ignore this word */
    				p+=strlen((char*)words[wc1].word);
    				break;
    			default:
    				/* an OK word */
    				ego_words[num_ego_words].id=words[wc1].id;
    				num_ego_words++;
    				p+=strlen((char*)words[wc1].word);
    				break;
    		}
    	}
    	else
    	{
    		/* unknown word */
			setvar(V_word_not_found, 1+num_ego_words);
    		p=(UINT8*)strchr((char*)p, 0x20);
    		num_ego_words++;
    	}
	}
}
